(* initial conditions *)

open Graphics;;
open Universe_graphics;;

(* mouse functions *)
type status = Graphics.status;;
let make_mouse_status () = wait_next_event [Poll];;
let click mouse_status = mouse_status.button;;

(* the universe and the buttons *)
let size_x = 800;;
let size_y = 600;;

let sx = 50;;
let sy = (size_y / 5) - 3;;
let by = 2;;

(* quit button *)
let quit_button =
  new button (size_x - (sx + 2)) by sx sy "Quit" blue;;
let on_quit = quit_button#pos;;
let quit() = exit 0;;

(* restart button *)
let by = by + sy + 2;;
let restart_button = 
  new button (size_x - (sx + 2)) by sx sy "Restart" blue;;
let on_restart = restart_button#pos;;


(* create ball button *)
let by = by + sy + 2;;
let create_ball_button = 
  new button (size_x - (sx + 2)) by sx sy "Ball" blue;;
let on_create_ball = create_ball_button#pos;;


(* create circle button *)
let by = by + sy + 2;;
let create_circle_button = 
  new button (size_x - (sx + 2)) by sx sy "Circle" blue;;
let on_create_circle = create_circle_button#pos;;

(* create sinusoide button *)
let by = by + sy + 2;;
let create_sinusoide_button = 
  new button (size_x - (sx + 2)) by sx sy "Sinus" blue;;
let on_create_sinusoide = create_sinusoide_button#pos;;


(* the universe *)
let the_universe =
  new universe 2 2 (size_x - (sx + 8)) (size_y - 7);;
let on_universe = the_universe#pos;;
let clear_universe () = the_universe#clear;;
let border = the_universe#border;;
let plot = the_universe#plot black 5;;
let clear_plot = the_universe#plot background 5;;

(* generating a random position and speed *)
let random_float = Random.float;;

let create_random_pos () =
  let x = Random.int size_x in
  let y = Random.int size_y in
  (float x,float y);;

let create_random_speed () =
  let dx = Random.int 20 in
  let dy = Random.int 20 in
  (float dx,float dy);;

(* initialisation *)
open_graph " 800x600+50-50";;
create_ball_button#draw;;
create_circle_button#draw;;
create_sinusoide_button#draw;;
restart_button#draw;;
quit_button#draw;;
the_universe#draw;;
