(* printing digits in base 16 *)
(* based on the idea of Pascal Raymond, VERIMAG *)

(* a very explicit and low-level implementation *)
let digit_zero =
  ((true,true,true),
   (true,false,true),
   (true,false,true),
   (true,false,true),
   (true,true,true))

let digit_one =
  ((false,false,true),
   (false,true,true),
   (true,false,true),
   (false,false,true),
   (false,false,true))

let digit_two =
  ((true,true,true),
   (false,false,true),
   (true,true,true),
   (true,false,false),
   (true,true,true))
;;

let digit_three =
  ((true,true,true),
   (false,false,true),
   (true,true,true),
   (false,false,true),
   (true,true,true))

let digit_four =
  ((true,false,false),
   (true,false,false),
   (true,true,true),
   (false,false,true),
   (false,false,true))

let digit_five =
  ((true,true,true),
   (true,false,false),
   (true,true,true),
   (false,false,true),
   (true,true,true))

let digit_six =
  ((true,true,true),
   (true,false,false),
   (true,true,true),
   (true,false,true),
   (true,true,true))

let digit_seven =
  ((true,true,true),
   (false,false,true),
   (false,true,true),
   (false,false,true),
   (false,false,true))

let digit_eight =
  ((true,true,true),
   (true,false,true),
   (true,true,true),
   (true,false,true),
   (true,true,true))

let digit_nine =
  ((true,true,true),
   (true,false,true),
   (true,true,true),
   (false,false,true),
   (true,true,true))

let digit_a =
  ((true,true,true),
   (true,false,true),
   (true,true,true),
   (true,false,true),
   (true,false,true))

let digit_b =
  ((true,false,false),
   (true,false,false),
   (true,true,true),
   (true,false,true),
   (true,true,true))

let digit_c =
  ((true,true,true),
   (true,false,false),
   (true,false,false),
   (true,false,false),
   (true,true,true))

let digit_d =
  ((false,false,true),
   (false,false,true),
   (true,true,true),
   (true,false,true),
   (true,true,true))

let digit_e =
  ((true,true,true),
   (true,false,true),
   (true,true,true),
   (true,false,false),
   (true,true,true))

let digit_f =
  ((true,true,true),
   (true,false,false),
   (true,true,false),
   (true,false,false),
   (true,false,false));;

let zero = (false,false,false,false)
and one = (false,false,false,true)
and two = (false,false,true,false)
and three = (false,false,true,true)
and four = (false,true,false,false)
and five = (false,true,false,true)
and six = (false,true,true,false)
and seven = (false,true,true,true)
and eight = (true,false,false,false)
and nine = (true,false,false,true)
and a = (true,false,true,false)
and b = (true,false,true,true)
and c = (true,true,false,false)
and d = (true,true,false,true)
and e = (true,true,true,false)
and f = (true,true,true,true);;

let convert v = 
  if v = zero then digit_zero
  else if v = one then digit_one
  else if v = two then digit_two
  else if v = three then digit_three
  else if v = four then digit_four
  else if v = five then digit_five
  else if v = six then digit_six
  else if v = seven then digit_seven
  else if v = eight then digit_eight
  else if v = nine then digit_nine
  else if v = a then digit_a
  else if v = b then digit_b
  else if v = c then digit_c
  else if v = d then digit_d
  else if v = e then digit_e
  else digit_f;;


let digit x3 x2 x1 x0 = convert (x3,x2,x1,x0);;

(* type the following commands:
   % lucys -x digit digit.ls
   % ./digit *)
