type tlucy_val = LV of string * (float * float) ;;
type 'a ntree = F of 'a | L of 'a ntree list | C of 'a ntree list ;;

let rec nbr_col = function
    F _ -> 1
  | L x -> List.fold_left max 1 (List.map nbr_col x)
  | C x -> (List.length x) * List.fold_left max 1 (List.map nbr_col x)
;;

let rec nbr_lignes = function
    F _ -> 1
  | C x -> List.fold_left max 1 (List.map nbr_lignes x)
  | L x -> (List.length x) * List.fold_left max 1 (List.map nbr_lignes x)
;;

let lv_of_l_ntree = function t ->
  let nl = nbr_lignes t in
  let nc = nbr_col t in
  let rec lvol x y = function
      F l -> F (l, (x, y))
    | C f -> C (List.map (lvol (x/.(float (List.length f))) y) f)
    | L f -> L (List.map (lvol x (y/.(float (List.length f)))) f)
  in
  lvol (float nc) (float nl) t
;;

let is_valid t =
  let rec iv s = function
    C l -> if s = "L" then List.for_all (iv "C") l else false
  | L l -> if s = "C" then List.for_all (iv "L") l else false
  | _ -> true
  in 
  (iv "C" t) || (iv "L" t)
;; 

let calc_coord i orig_x orig_y taille_x taille_y tree = 
  let rec cc i orig_x orig_y ll = function
      F (l, (x,y)) -> 
        let fx = orig_x + ((truncate (x *. (float taille_x)))) in
        let fy = orig_y - ((truncate (y *. (float taille_y)))) in
        (i+1, fx, fy, (i, l, orig_x, (fy+5)*5/5, 
	      (fx-5)*5/5, orig_y)::ll)
    | L l -> 
        List.fold_left (fun (j,x,y,t) z -> cc j orig_x y t z) 
          (i, orig_x, orig_y, ll) l
    | C l -> 
        List.fold_left (fun (j,x,y,t) z -> cc j x orig_y t z)
          (i, orig_x, orig_y, ll) l
  in
  let (idf, xf, yf, lf) = cc i orig_x orig_y [] (lv_of_l_ntree tree) in lf
;;

